@MISC{ns3,
	key = {{ns-3}},
	title = {{ns-3}},
	note = {
	\url{https://www.nsnam.org/}
	},
	language = {english},
}   
  
@MISC{m3,
	key = {{m3}},
	title = {{ARM Cortex-M3 Processor Technical Reference Manual}},
	language = {english},
}

@MISC{ebpfins,
	key = {{eBPF Instruction Set}},
	title = {{eBPF Instruction Set}},
	note = {
	\url{https://github.com/iovisor/bpf-docs/blob/master/eBPF.md}
	},
	language = {english},
}

@MISC{tofino,
	key = {{Tofino}},
	title = {{Barefoot Tofino}},
	note = {
	\url{https://barefootnetworks.com/products/brief-tofino/}
	},
	language = {english},
}

@MISC{xplaint,
	key = {{xplaint}},
	title = {{Cavium XPliant}},
	note = {
	\url{http://www.cavium.com/pdfFiles/CNX880XX_PB_Rev1.pdf}
	},
	language = {english},
}

@MISC{Jericho2,
	key = {{Jericho2}},
	title = {{Brodcom Jericho2}},
	note = {
	\url{https://www.broadcom.com/news/product-releases/broadcom-ships-jericho2}
	},
	language = {english},
} 

@MISC{dpdk,
	key = {{dpdk}},
	title = {{Data Plane Development Kit (DPDK)}},
	note = {
	\url{http://dpdk.org/}
	},
	language = {english},
}

@MISC{ceth,
	key = {{ceth}},
	title = {{CETH: Huawei's XDP implementation}},
	note = {
	\url{https://www.slideshare.net/IOVisor/ceth-for-xdp-linux-meetup-santa-clara-july-2016}
	},
	language = {english},
}

@MISC{napi,
	key = {{napi}},
	title = {{Linux New API (NAPI)}},
	note = {
	\url{https://wiki.linuxfoundation.org/networking/napi}
	},
	language = {english},
}


@MISC{zol,
	key = {{zol}},
	title = {{Zero Overhead Linux}},
	note = {
	\url{http://opennpu.org/wp-content/uploads/2017/02/NPS-400_programming_3_3_Open.pdf}
	},
	language = {english},
}

@MISC{openpu,
	key = {{openpu}},
	title = {{OpenNPU}},
	note = {
	\url{http://opennpu.org/}
	},
	language = {english},
}

@MISC{vpp,
	key = {{vpp}},
	title = {{Vector Packet Processing (VPP)}},
	note = {
	\url{https://wiki.fd.io/view/VPP}
	},
	language = {english},
}

@MISC{6wind,
	key = {{6wind}},
	title = {{Spanish ISP Replaces Cisco Hardware Routers With 6WIND vRouter}},
	note = {
	\url{https://www.sdxcentral.com/articles/news/spanish-isp-replaces-cisco-hardware-routers-with-6wind-vrouter/2018/06/}
	},
	language = {english},
}

@MISC{xdp,
	key = {{XDP}},
	title = {{XDP (eXpress Data path)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
	},
	language = {english},
}

@techreport{linguaglossa2017high,
	title={{High-speed software data plane via vectorized packet processing}),
	author={Linguaglossa, Leonardo and Rossi, Dario and Barach, Dave and Marjon, Damjan and Pfiester, Pierre},
	year={2017},
	institution={Technical report, Telecom ParisTech, CNIT and University of Rome Tor Vergata, Systems, Inc., 2018. 5}
	}
	
	
	@MISC{odp,
	key = {{odp}},
	title = {{OpenDataPlane(ODP)}},
	note = {
	\url{https://www.opendataplane.org/}
	},
	language = {english},
	} 
	
	@MISC{rcu,
	key = {{RCU}},
	title = {{Read-copy-update(RCU)}},
	note = {
	\url{https://en.wikipedia.org/wiki/Read-copy-update}
	},
	language = {english},
	} 
	
	@MISC{xdp,
	key = {{XDP}},
	title = {{XDP (eXpress Data path)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
	},
	language = {english},
	} 
	
	@article{nilsson1999ip,
	title={{IP-address lookup using LC-tries}},
	author={Nilsson, Stefan and Karlsson, Gunnar},
	journal={IEEE Journal on selected Areas in Communications},
	volume={17},
	number={6},
	pages={1083--1092},
	year={1999},
	}
	
	
	@inproceedings{yang2014guarantee,
	title={{Guarantee IP lookup performance with FIB explosion}},
	author={Yang, Tong and Xie, Gaogang and Li, YanBiao and Fu, Qiaobin and Liu, Alex X and Li, Qi and Mathy, Laurent},
	booktitle={ACM SIGCOMM 2014},
	}
	
	@inproceedings{asai2015poptrie,
	title={{Poptrie: A compressed trie with population count for fast and scalable software IP routing table lookup}},
	author={Asai, Hirochika and Ohara, Yasuhiro},
	booktitle={ACM SIGCOMM 2015},
	}
	
	@article{eatherton2004tree,
	title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
	author={Eatherton, Will and Varghese, George and Dittia, Zubin},
	journal={ACM SIGCOMM},
	volume={34},
	number={2},
	pages={97--122},
	year={2004},
	}
	
	
	@inproceedings{rizzo2012netmap,
	title={{Netmap: a novel framework for fast packet I/O}},
	author={Rizzo, Luigi},
	booktitle={21st USENIX Security Symposium (USENIX Security 12)},
	pages={101--112},
	year={2012}
	}
	
	
	@MISC{ebpf,
	key = {{ebpf}},
	title = {{eBPF (extened Binary Packet Filter)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/bpf/}
	},
	language = {english},
	}
 	
	@MISC{qfp,
	key = {{qfp}},
	title = {{Cisco Quantum Flow Processor}},
	note = {
	\url{https://www.cisco.com/c/en/us/products/collateral/routers/asr-1000-series-aggregation-services-routers/solution_overview_c22-448936.html}
	},
	language = {english},
	}
	
	
	@MISC{qfpchipset,
	key = {{qfpchipset}},
	title = {{The QFP Packet Processing Chip Set}},
	note = {
	\url{https://www.hotchips.org/wp-content/uploads/hc_archives/hc20/3_Tues/HC20.26.720.pdf}
	},
	language = {english},
	}
	
	@article{esilicon,
	title={{High-Performance Network Data-Packet Classification Using Embedded Content-Addressable Memory}},
	author={Wheeler, Bob},
	journal={eSilicon White Paper},
	\url{https://www.esilicon.com/wp-content/uploads/High-Performance-Network-Data-Packet-Classification-Using-Embedded-Content-Addressable-Memory-TCAMs.pdf}	
	year={2014}
	}
	
	@MISC{nPower,
	key = {{nPower}},
	title = {{Cisco nPower X1}},
	note = {
	\url{https://www.cisco.com/c/en/us/solutions/collateral/optical-networking/ons-15454-series-multiservice-provisioning-platforms/solution_overview_c22-729610.pdf}
	},
	language = {english},
	}
	
	@MISC{trio,
	key = {{trio}},
	title = {{Juniper Trio}},
	note = {
	\url{https://forums.juniper.net/t5/Service-Provider-Transformation/Trio-Packet-Processing-Overview/ba-p/295653/}
	},
	language = {english},
	} 
	
	@MISC{triomemory,
	key = {{triomemory}},
	title = {{Juniper Trio Memory Unit}},
	note = {
	\url{https://forums.juniper.net/t5/Archive/Trio-Packet-Processing-Memory-System/ba-p/296175}
	},
	language = {english},
	}

	@MISC{triome,
	key = {{triome}},
	title = {{Juniper Trio Micro Engine}},
	note = {
	\url{https://forums.juniper.net/t5/Archive/Trio-Packet-Processing-PPE/ba-p/296173}
	},
	language = {english},
	}
	
	@book{hanks2016juniper,
	title={{Juniper MX Series, A Comprehensive Guide to Trio Technologies on the MX}},
	author={Hanks, Douglas and Reynolds, Harry},
	year={second edition, 2016},
	publisher={" O'Reilly Media, Inc."}
	}
	
	
	@MISC{fp4,
	key = {{fp4}},
	title = {{Nokia FP4}},
	note = {
	\url{http://www.gazettabyte.com/home/2017/7/5/the-era-of-cloud-scale-routeing.html/}
	},
	language = {english},
	}
	
	
	@article{nPowerX2,
	title={{A Rare Peek Inside A 400G Cisco Network Chip}},
	author={James Markevitch, Srinivasa Malladi},
	journal={HotChip},
	year={2017}
	}
	
	@article{jain2014current,
	title={{Current Status of Network Processors}},
	author={Jain, Neha and Jain, Manoj Kumar},
	journal={International Journal of Computer Applications},
	volume={98},
	number={12},
	year={2014},
	publisher={Foundation of Computer Science}
	}
	
	
	@article{wheeler2013new,
	title={{A new era of network processing}},
	author={Wheeler, Bob},
	journal={The Linley Group, Tech. Rep},
	year={2013}
	}
	
	
	@article{xeon,
	title={{One Terabit Software Router on Intel Xeon Scalable Processor Family}},
	journal={FD.io - Vector Packet Processing white paper},
	year={2013}
	}
	
	@article{enp,
	title={{HUAWEI Sx700 Series Switches}},
	journal={ENP Technology White Paper},
	year={2014}
	}
	
	@article{enea,
	title={{Fundamentals OF Multicore : Operating Systems for Telecom/Networking Applications}},
	author={Michael Christofferson},
	journal={ENEA White paper},
	year={2010}
	}
	
	@MISC{ebpf,
	key = {{ebpf}},
	title = {{eBPF (extened Binary Packet Filter)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/bpf/}
	},
	language = {english},
	}
	
	@MISC{qfp,
	key = {{qfp}},
	title = {{Cisco Quantum Flow Processor based router}},
	note = {
	\url{https://www.cisco.com/c/en/us/products/collateral/routers/asr-1000-series-aggregation-services-routers/solution_overview_c22-448936.html}
	},
	language = {english},
	} 
	
	
	@article{esilicon,
	title={{High-Performance Network Data-Packet Classification Using Embedded Content-Addressable Memory}},
	author={Wheeler, Bob},
	journal={eSilicon White Paper},
	\url{https://www.esilicon.com/wp-content/uploads/High-Performance-Network-Data-Packet-Classification-Using-Embedded-Content-Addressable-Memory-TCAMs.pdf}	
	year={2014}
	} 
	  
	@MISC{nPower,
	key = {{nPower}},
	title = {{Cisco nPower X1}},
	note = {
	\url{https://www.cisco.com/c/en/us/solutions/collateral/optical-networking/ons-15454-series-multiservice-provisioning-platforms/solution_overview_c22-729610.pdf}
	},
	language = {english},
	}
	
	@article{nPowerX2,
	title={{A Rare Peek Inside A 400G Cisco Network Chip}},
	author={James Markevitch, Srinivasa Malladi},
	journal={HotChip},
	year={2017}
	}
	
	@article{jain2014current,
	title={{Current Status of Network Processors}},
	author={Jain, Neha and Jain, Manoj Kumar},
	journal={International Journal of Computer Applications},
	volume={98},
	number={12},
	year={2014},
	publisher={Foundation of Computer Science}
	}
	 
	
	@article{wheeler2013new,
	title={{A new era of network processing}},
	author={Wheeler, Bob},
	journal={The Linley Group, Tech. Rep},
	year={2013}
	}
	
	
	@article{xeon,
	title={{One Terabit Software Router on Intel Xeon Scalable Processor Family}},
	journal={FD.io - Vector Packet Processing white paper},
	year={2013}
	}
	
	@article{enea,
	title={{Fundamentals OF Multicore : Operating Systems for Telecom/Networking Applications}},
	author={Michael Christofferson},
	journal={ENEA White paper},
	year={2010}
	} 
	
	
	@MISC{flexpipe,
	key = {{flexpipe}},
	title = {{Intel FlexPipe switch}},
	note = {
	\url{http://www.intel.com/content/www/us/en/ethernet-products/switch-silicon/ethernet-switch-fm5000-fm6000-series.html}
	},
	language = {english},
	}   
	
	
	@MISC{nfp,
	key = {{nfp}},
	title = {{Netronome NFP samrt NIC}},
	note = {
	\url{https://www.netronome.com/media/redactor_files/WP_NFP4000_TOO.pdf}
	},
	language = {english},
	}
	
	@MISC{octeon,
	key = {{octeon}},
	title = {{Marvell OCTEON smart NIC}},
	note = {
	\url{https://www.marvell.com/embedded-processors/infrastructure-processors/octeon-multi-core-mips64-processors/index.jsp/}
	},
	language = {english},
	} 
	
	@MISC{mellanox,
	key = {{mellanox}},
	title = {{Mellanox NPS 400}},
	note = {
	\url{http://www.tilera.com/files/drim__NPS-400_Product_Brief_short_Jan2015_7596.pdf}
	},
	language = {english},
	} 
	
	@MISC{zol,
	key = {{zol}},
	title = {{Zero Overhead Linux}},
	note = {
	\url{http://opennpu.org/wp-content/uploads/2017/02/NPS-400_programming_3_3_Open.pdf}
	},
	language = {english},
	}
	
	@book{love2005linux,
	title={Linux Kernel Development (Novell Press)},
	author={Love, Robert},
	year={2005},
	publisher={Novell Press}
	}
	
	
	@inproceedings{eatherton2008qfp,
	title={{The QFP packet processing chip set}},
	author={Eatherton, Will and Steiss, Don and Markevitch, James},
	booktitle={IEEE Hot Chips 20 Symposium},
	pages={1--22},
	year={2008}
	}
	
	
	@inproceedings{lantz2010network,
	title={{A network in a laptop: rapid prototyping for software-defined networks}},
	author={Lantz, Bob and Heller, Brandon and McKeown, Nick},
	booktitle={Proceedings of the 9th ACM SIGCOMM Workshop on Hot Topics in Networks},
	year={2010},
	} 
	
	@MISC{gstreamer,
	key = {{GStreamer}},
	title = {{GStreamer}},
	note = {
	\url{https://gstreamer.freedesktop.org/}
	},
	language = {english},
	}  
	
	
	@MISC{huawei,
	key = {Huawei},
	title = {{White Paper for HDTV Bearer Networks - Huawei}},
	note = {
	\url{http://www1.huawei.com/en/static/HW-076764.pdf}
	},
	language = {english},
	}  
	
	#Free viewpoint video
	
	@article{collet2015high,
	title={{High-quality streamable free-viewpoint video}},
	author={Collet, Alvaro and Chuang, Ming and Sweeney, Pat and Gillett, Don and Evseev, Dennis and Calabrese, David and Hoppe, Hugues and Kirk, Adam and Sullivan, Steve},
	journal={ACM Transactions on Graphics (TOG)},
	volume={34},
	number={4},
	pages={69},
	year={2015},
	}
	
	#RCP 
	
	@inproceedings{dukkipati2005processor,
	title={{Processor sharing flows in the Internet}},
	author={Dukkipati, Nandita and Kobayashi, Masayoshi and Zhang-Shen, Rui and McKeown, Nick},
	booktitle={IWQoS},
	pages={271--285},
	year={2005}
	}
	 
	
	@article{dukkipati2006flow,
	title={{Why flow-completion time is the right metric for congestion control}},
	author={Dukkipati, Nandita and McKeown, Nick},
	journal={ACM SIGCOMM CCR},
	volume={36},
	number={1},
	pages={59--62},
	year={2006},
	}
	
	@phdthesis{dukkipati2007rate,
	title={{Rate Control Protocol (RCP): Congestion control to make flows complete quickly}},
	author={Dukkipati, Nandita},
	year={2007},
	school={PhD thesis,	Stanford University}
	}
	
	@inproceedings{tai2008making,
	title={{Making large scale deployment of RCP practical for real networks}},
	author={Tai, C-H and Zhu, Jiang and Dukkipati, Nandita},
	booktitle={IEEE INFOCOM},
	pages={2180--2188},
	year={2008}
	}
	
	@inproceedings{dukkipati2007building,
	title={Building a RCP (rate control protocol) test network},
	author={Dukkipati, Nandita and Gibb, Glen and McKeown, Nick and Zhu, Jiang},
	booktitle={IEEE Symposium on High-Performance Interconnects},
	pages={91--98},
	year={2007}
	}

	
	#XCP
	@inproceedings{katabi2002internet,
	title={{Internet Congestion Control for Future High Bandwidth-Delay Product}},
	author={Katabi, Dina and Handley, Mark and Rohrs, Charlie and Tellabs, Mit-lcs Icsi},
	booktitle={ACM SIGCOMM},
	year={2002},
	}
	
	@inproceedings{hauger2008quick,
	title={{Quick-Start and XCP on a network processor: Implementation issues and performance evaluation}},
	author={Hauger, Simon and Scharf, Michael and Kogel, Jochen and Suriyajan, Chawapong},
	booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
	pages={241--246},
	year={2008}
	}

	
	@inproceedings{tamim,
	title={{A network-centric TCP for interactive video delivery networks (VDN)}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE International Conference on Network Protocols (ICNP)},
	pages={1--6},
	year={2017}
	}
	
	@inproceedings{tamimsail,
	title={{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
	year={2019}
	}
	
	@inproceedings{tamimrcp,
	title={{Leveraging Domino to Implement RCP in a Stateful Programmable Pipeline}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
	year={2019}
	}
	
	@inproceedings{narayana2017language,
	title={Language-directed hardware design for network performance monitoring},
	author={Narayana, Srinivas and Sivaraman, Anirudh and Nathan, Vikram and Goyal, Prateesh and Arun, Venkat and Alizadeh, Mohammad and Jeyakumar, Vimalkumar and Kim, Changhoon},
	booktitle={ACM SIGCOMM},
	pages={85--98},
	year={2017}
	}

	
	@inproceedings{openqueue,
	title={{A programmable buffer management platform}},
	author={Kogan, Kirill and Menikkumbura, Danushka and Petri, Gustavo and Noh, Yangtae and Nikolenko, Sergey and Sirotkin, Alexander and Eugster, Patrick},
	booktitle={IEEE International Conference on Network Protocols (ICNP)},
	year={2017}
	}

	
	@inproceedings{honda2011still,
	title={{Is it still possible to extend TCP?}},
	author={Honda, Michio and Nishida, Yoshifumi and Raiciu, Costin and Greenhalgh, Adam and Handley, Mark and Tokuda, Hideyuki},
	booktitle={ACM SIGCOMM IMC},
	pages={181--194},
	year={2011},
	} 
	
	@article{eddy2008extending,
	title={{Extending the space available for TCP options}},
	author={Eddy, W and Langley, A},
	journal={draft-eddy-tcp-loo-04},
	year={2008}
	}
	 
	@inproceedings{raiciu2012hard,
	title={{How hard can it be? designing and implementing a deployable multipath TCP}},
	author={Raiciu, Costin and Paasch, Christoph and Barre, Sebastien and Ford, Alan and Honda, Michio and Duchene, Fabien and Bonaventure, Olivier and Handley, Mark},
	booktitle={USENIX NSDI},
	pages={29--29},
	year={2012},
	}
	
	@article{floyd1994tcp,
	title={{TCP and explicit congestion notification}},
	author={Floyd, Sally},
	journal={ACM SIGCOMM CCR},
	volume={24},
	number={5},
	pages={8--23},
	year={1994},
	}
	
	#SDN
	 
	
	@article{bosshart2014p4,
	title={{P4: Programming protocol-independent packet processors}},
	author={Bosshart, Pat and Daly, Dan and Gibb, Glen and Izzard, Martin and McKeown, Nick and Rexford, Jennifer and Schlesinger, Cole and Talayco, Dan and Vahdat, Amin and Varghese, George and others},
	journal={ACM SIGCOMM Computer Communication
	Review},
	volume={44},
	number={3},
	pages={87--95},
	year={2014},
	}
	
	@inproceedings{jose2015compiling,
	title={{Compiling Packet Programs to Reconfigurable Switches.}},
	author={Jose, Lavanya and Yan, Lisa and Varghese, George and McKeown, Nick},
	booktitle={NSDI},
	pages={103--115},
	year={2015}
	}
	
	
	@article{anderson2005overcoming,
	title={{Overcoming the Internet impasse through virtualization}},
	author={Anderson, Thomas and Peterson, Larry and Shenker, Scott and Turner, Jonathan},
	journal={Computer},
	volume={38},
	number={4},
	pages={34--41},
	year={2005}
	} 
	
	@article{blenk2016survey,
	title={Survey on network virtualization hypervisors for software defined networking},
	author={Blenk, Andreas and Basta, Arsany and Reisslein, Martin and Kellerer, Wolfgang},
	journal={IEEE Communications Surveys \& Tutorials},
	volume={18},
	number={1},
	pages={655--685},
	year={2016},
	}
	
	@article{ordonez2017network,
	title={{Network Slicing for 5G with SDN/NFV: Concepts, Architectures, and Challenges}},
	author={Ordonez-Lucena, Jose and Ameigeiras, Pablo and Lopez, Diego and Ramos-Munoz, Juan J and Lorca, Javier and Folgueira, Jesus},
	journal={IEEE Communications Magazine},
	volume={55},
	number={5},
	pages={80--87},
	year={2017},
	}
	
	#Medianet
	
	@inproceedings{khan2002symbiotic,
	title={{Symbiotic Video Streaming by Transport Feedback based quality rate selection}},
	author={Khan, Javed I and Gu, Qiong and Zaghal, Raid},
	booktitle={Proceedings of the 12th IEEE International Packet Video Workshop},
	year={2002}
	}
	
	@inproceedings{khan2007event,
	title={{Event based Extensible Interactive Transparent Networking: Performance Study with Fast TCP Principles}},
	author={Khan, Javed I and Punnam, Pradeep K and Zaghal, Raid},
	booktitle={IEEE AINA},
	pages={281--288},
	year={2007},
	} 
	
	@inproceedings{khan2003jitter,
	title={{Jitter and delay reduction for time sensitive elastic traffic for TCP-interactive based world wide video streaming over ABone}},
	author={Khan, Javed I and Zaghal, Raid Y},
	booktitle={IEEE ICCCN},
	pages={311--316},
	year={2003}, 
	}
	
	@inproceedings{islam2015video,
	title={{Video Splicing Techniques for P2P Video Streaming}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE ICDCS Workshop},
	pages={72--76},
	year={2015},
	}
	
	#TCP
	
	@inproceedings{hayes2013common,
	title={{Common TCP Evaluation Suite}},
	author={L. Andrew, S. Floyd, G. Wang},
	year={2009},
	booktitle={IETF Informational Draft}
	}
	
	@inproceedings{islam2014coupled,
	title={{Coupled congestion control for RTP media}},
	author={Islam, Safiqul and Welzl, Michael and Gjessing, Stein and Khademi, Naeem},
	booktitle={ACM SIGCOMM CCR},
	volume={44},
	number={4},
	pages={21--26},
	year={2014},
	}
	
	
	@article{budzisz2011fair,
	title={{On the fair coexistence of loss-and delay-based TCP}},
	author={Budzisz, {\L}ukasz and Stanojevi{\'c}, Rade and Schlote, Arieh and Baker, Fred and Shorten, Robert},
	journal={IEEE/ACM Transactions on Networking (TON)},
	volume={19},
	number={6},
	pages={1811--1824},
	year={2011}, 
	} 
	
	@inproceedings{winstein2013stochastic,
	title={{Stochastic forecasts achieve high throughput and low delay over cellular networks}},
	author={Winstein, Keith and Sivaraman, Anirudh and Balakrishnan, Hari},
	booktitle={USENIX NSDI},
	pages={459--471},
	year={2013}
	}
	
	@article{floyd2003highspeed,
	title={{HighSpeed TCP for large congestion windows}},
	author={Floyd, Sally},
	year={2003}
	}
	
	@article{ha2008cubic,
	title={{CUBIC: a new TCP-friendly high-speed TCP variant}},
	author={Ha, Sangtae and Rhee, Injong and Xu, Lisong},
	journal={ACM SIGOPS Operating Systems Review},
	year={2008},
	}
	
	@article{brakmo1995tcp,
	title={{TCP Vegas: End to end congestion avoidance on a global Internet}},
	author={Brakmo, Lawrence S. and Peterson, Larry L.},
	journal={IEEE Journal on selected Areas in communications},
	volume={13},
	number={8},
	pages={1465--1480},
	year={1995}
	}
	
	@article{wei2006fast,
	title={{FAST TCP: motivation, architecture, algorithms, performance}},
	author={Wei, David X and Jin, Cheng and Low, Steven H and Hegde, Sanjay},
	journal={IEEE/ACM Transactions on Networking},
	volume={14},
	number={6},
	pages={1246--1259},
	year={2006}
	} 
	
	
	@article{grieco2004performance,
	title={{Performance evaluation and comparison of Westwood+, New Reno, and Vegas TCP congestion control}},
	author={Grieco, Luigi A and Mascolo, Saverio},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={34},
	number={2},
	pages={25--38},
	year={2004}
	}
	
	@inproceedings{rossi2010ledbat,
	title={{LEDBAT: The New BitTorrent Congestion Control Protocol.}},
	author={Rossi, Dario and Testa, Claudio and Valenti, Silvio and Muscariello, Luca},
	booktitle={IEEE ICCCN},
	pages={1--6},
	year={2010}
	}
	
	@inproceedings{parsa1999improving,
	title={{Improving TCP congestion control over internets with heterogeneous transmission media}},
	author={Parsa, Christina and Garcia-Luna-Aceves, JJ},
	booktitle={IEEE ICNP},
	pages={213--221},
	year={1999}
	}
	
	@inproceedings{carofiglio2010quest,
	title={{The quest for LEDBAT fairness}},
	author={Carofiglio, Giovanna and Muscariello, Luca and Rossi, Dario and Valenti, Silvio},
	booktitle={IEEE GLOBECOM},
	pages={1--6},
	year={2010}
	}
	
	
	@inproceedings{hayes2011revisiting,
	title={{Revisiting TCP congestion control using delay gradients}},
	author={Hayes, David A and Armitage, Grenville},
	booktitle={IFIP Networking},
	pages={328--341},
	year={2011},
	organization={Springer}
	}
	
	@inproceedings{shewmaker2016tcp,
	title={{TCP Inigo: Ambidextrous congestion control}},
	author={Shewmaker, Andrew G and Maltzahn, Carlos and Obraczka, Katia and Brandt, Scott and Bent, John},
	booktitle={IEEE ICCCN},
	pages={1--10},
	year={2016}
	} 
	
	@inproceedings{kuhlewind2014using,
	title={{Using data center TCP (DCTCP) in the Internet}},
	author={K{\"u}hlewind, Mirja and Wagner, David P and Espinosa, Juan Manuel Reyes and Briscoe, Bob},
	booktitle={IEEE Globecom Workshops, 2014},
	pages={583--588},
	year={2014}
	}
	
	@inproceedings{zaki2015adaptive,
	title={{Adaptive congestion control for unpredictable cellular networks}},
	author={Zaki, Yasir and P{\"o}tsch, Thomas and Chen, Jay and Subramanian, Lakshminarayanan and G{\"o}rg, Carmelita},
	booktitle={ACM SIGCOMM CCR},
	volume={45},
	number={4},
	pages={509--522},
	year={2015}
	}
	
	@inproceedings{mittal2015timely,
	title={{TIMELY: RTT-based Congestion Control for the Datacenter}},
	author={Mittal, Radhika and Dukkipati, Nandita and Blem, Emily and Wassel, Hassan and Ghobadi, Monia and Vahdat, Amin and Wang, Yaogong and Wetherall, David and Zats, David and others},
	booktitle={ACM SIGCOMM CCR},
	volume={45},
	number={4},
	pages={537--550},
	year={2015}
	}
	 
	@article{45646,
	title = {{BBR: Congestion-Based Congestion Control}},
	author  = {Neal Cardwell and Yuchung Cheng and C. Stephen Gunn and Soheil Hassas Yeganeh and Van Jacobson},
	year  = 2016,
	journal = {ACM Queue},
	pages = {20 - 53},
	}
	
	
	#TCP Pacing
	@inproceedings{aggarwal2000understanding,
	title={{Understanding the performance of TCP pacing}},
	author={Aggarwal, Amit and Savage, Stefan and Anderson, Thomas},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1157--1165},
	year={2000}
	} 
	
	#UDP
	
	@article{floyd2000equation,
	title={{Equation-based congestion control for unicast applications}},
	author={Floyd, Sally and Handley, Mark and Padhye, Jitendra and Widmer, J{\"o}rg},
	journal={ACM SIGCOMM CCR},
	volume={30},
	number={4},
	pages={43--56},
	year={2000},
	}  
	
	
	@inproceedings{rejaie1999rap,
	title={{RAP: An end-to-end rate-based congestion control mechanism for realtime streams in the Internet}},
	author={Rejaie, Reza and Handley, Mark and Estrin, Deborah},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1337--1345}, 
	year={1999}
	} 
	
	@inproceedings{zhu2013nada,
	title={{NADA: A unified congestion control scheme for low-latency interactive video}},
	author={Zhu, Xiaoqing and Pan, Rong},
	booktitle={IEEE International Packet Video Workshop},
	pages={1--8},
	year={2013}, 
	}  
	
	@inproceedings{o2013dflow, 
	title={{Dflow: Low latency congestion control}},
	author={O'Hanlon, Piers and Carlberg, Ken},
	booktitle={IEEE ICNP},
	pages={1--6},
	year={2013}
	}
	
	@article{lundin2012google,
	title={{A google congestion control algorithm for real-time communication on the world wide web}},
	author={Lundin, H and Holmer, S and Alvestrand, H},
	journal={IETF Informational Draft},
	year={2012}
	}
	
	@inproceedings{de2013experimental,
	title={{Experimental investigation of the google congestion control for real-time flows}},
	author={De Cicco, Luca and Carlucci, Gaetano and Mascolo, Saverio},
	booktitle={ACM SIGCOMM workshop on Future human-centric multimedia networking},
	pages={21--26},
	year={2013},
	} 
	
	@inproceedings{carlucci2016analysis,
	title={{Analysis and design of the Google Congestion Control for web real-time communication (WebRTC)}},
	author={Carlucci, Gaetano and De Cicco, Luca and Holmer, Stefan and Mascolo, Saverio},
	booktitle={ACM Multimedia Systems (MMSys)},
	pages={13},
	year={2016},
	}
	
	@inproceedings{carlucci2016congestion,
	title={{Congestion control for real-time communications: A comparison between NADA and GCC}},
	author={Carlucci, Gaetano and De Cicco, Luca and Ilharco, Cesar and Mascolo, Saverio},
	booktitle={IEEE Mediterranean Conference on Control and Automation (MED)},
	pages={575--580},
	year={2016},
	}
	
	@article{carlucci2016controlling,
	title={{Controlling Queuing Delays for Real-Time Communication: The Interplay of E2E and AQM Algorithms}},
	author={Carlucci, Gaetano and De Cicco, Luca and Mascolo, Saverio},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={46},
	number={3},
	year={2016}
	}
	
	@inproceedings{zhang2012profiling,
	title={{Profiling skype video calls: Rate control and video quality}},
	author={Zhang, Xinggong and Xu, Yang and Hu, Hao and Liu, Yong and Guo, Zongming and Wang, Yao},
	booktitle={IEEE INFOCOM},
	pages={621--629},
	year={2012},
	}
	
	@inproceedings{zhu2010layered,
	title={{Layered internet video engineering (LIVE): Network-assisted bandwidth sharing and transient loss protection for scalable video streaming}},
	author={Zhu, Xiaoqing and Pan, Rong and Dukkipati, Nandita and Subramanian, Vijay and Bonomi, Flavio},
	booktitle={INFOCOM, 2010 Proceedings IEEE},
	pages={1--5},
	year={2010},
	organization={IEEE}
	}
	
	#SCTP
	
	@article{ong2002introduction,
	title={{An introduction to the stream control transmission protocol (SCTP)}},
	author={Ong, Lyndon},
	year={2002}
	}
	
	#DCCP 
	
	@inproceedings{kohler2006designing,
	title={{Designing DCCP: Congestion control without reliability}},
	author={Kohler, Eddie and Handley, Mark and Floyd, Sally},
	booktitle={ACM SIGCOMM Computer Communication Review},
	volume={36},
	number={4},
	pages={27--38},
	year={2006},
	}
	
	#DX
	@inproceedings{lee2015accurate,
	title={{Accurate Latency-based Congestion Feedback for Datacenters.}},
	author={Lee, Changhyun and Park, Chunjong and Jang, Keon and Moon, Sue B and Han, Dongsu},
	booktitle={USENIX Annual Technical Conference},
	pages={403--415},
	year={2015}
	}
	
	#TCP multimedia
	
	@inproceedings{nowlan2012fitting,
	title={{Fitting square pegs through round pipes: Unordered delivery wire-compatible with TCP and TLS}},
	author={Nowlan, Michael F and Tiwari, Nabin and Iyengar, Janardhan and Amin, Syed Obaid and Ford, Bryan},
	booktitle={USENIX NSDI},
	year={2012}
	}
	
	@inproceedings{mukherjee2000time,
	title={{Time-lined TCP for the TCP-friendly delivery of streaming media}},
	author={Mukherjee, Biswaroop and Brecht, Tim},
	booktitle={IEEE ICNP},
	pages={165--176},
	year={2000},
	}
	
	@inproceedings{mcquistin2016tcp,
	title={{TCP Hollywood: An unordered, time-lined, TCP for networked multimedia applications}},
	author={McQuistin, Stephen and Perkins, Colin and Fayed, Marwan},
	booktitle={IFIP Networking},
	pages={422--430},
	year={2016},
	}
	
	#router chache
	
	@inproceedings{valera2003cooperative,
	title={Cooperative packet caching and shortest multipath routing in mobile ad hoc networks},
	author={Valera, Alvin and Seah, Winston Khoon Guan and Rao, SV},
	booktitle={IEEE INFOCOM},
	year={2003},
	}
	
	@article{he2008toward,
	title={Toward internet-wide multipath routing},
	author={He, Jiayue and Rexford, Jennifer},
	journal={IEEE network},
	year={2008},
	}
	
	#Queue
	@article{nichols2012modern,
	title={{A Modern AQM is just one piece of the solution to bufferbloat}},
	author={Nichols, K and Jacobson, V},
	journal={ACM Queue Networks},
	volume={10},
	number={5},
	year={2012}
	}
	
	@article{gettys2011bufferbloat,
	title={{Bufferbloat: Dark buffers in the Internet}},
	author={Gettys, Jim and Nichols, Kathleen},
	journal={ACM Queue},
	volume={9},
	number={11},
	pages={40},
	year={2011},
	publisher={ACM}
	}
	
	@inproceedings{pan2013pie,
	title={{PIE: A lightweight control scheme to address the bufferbloat problem}},
	author={Pan, Rong and Natarajan, Preethi and Piglione, Chiara and Prabhu, Mythili Suryanarayana and Subramanian, Vijay and Baker, Fred and VerSteeg, Bill},
	booktitle={IEEE High Performance Switching and Routing (HPSR)},
	pages={148--155},
	year={2013}
	}
	
	@inproceedings{de2016pi2,
	title={{PI2: A Linearized AQM for both Classic and Scalable TCP}},
	author={De Schepper, Koen and Bondarenko, Olga and Tsang, Jyh and Briscoe, Bob},
	booktitle={ACM CoNEXT},
	pages={105--119},
	year={2016}
	}
	
	#Media Friendliness
	@article{yan2006media,
	title={{Media-and TCP-friendly congestion control for scalable video streams}},
	author={Yan, Jinyao and Katrinis, Kostas and May, Martin and Plattner, Bernhard},
	journal={IEEE Transactions on Multimedia},
	volume={8},
	number={2},
	pages={196--206},
	year={2006},
	}  
	
	@inproceedings{wang2004multimedia,
	title={{Multimedia streaming via TCP: an analytic performance study}},
	author={Wang, Bing and Kurose, Jim and Shenoy, Prashant and Towsley, Don},
	booktitle={ACM Multimedia},
	pages={908--915},
	year={2004},
	}
	
	@inproceedings{wang2004media,
	title={{Media-friendliness of a slowly-responsive congestion control protocol}},
	author={Wang, Zhiheng and Banerjee, Sujata and Jamin, Sugih},
	booktitle={ACM NOSSDAV Workshop},
	pages={82--87},
	year={2004},
	}
	
	@inproceedings{brosh2008delay,
	title={{The delay-friendliness of TCP}},
	author={Brosh, Eli and Baset, Salman Abdul and Rubenstein, Dan and Schulzrinne, Henning},
	booktitle={ACM SIGMETRICS Performance Evaluation Review},
	volume={36},
	number={1},
	pages={49--60},
	year={2008},
	}
	
	#Teleemersion
	
	@inproceedings{chen2016f,
	title={{F. Live: Towards interactive live broadcast FTV experience}},
	author={Chen, Shannon and Gao, Zhenhuan and Nahrstedt, Klara},
	booktitle={IEEE INFOCOM},
	pages={1--9},
	year={2016},
	}
	
	@inproceedings{arefin2013prioritized,
	title={{Prioritized evolutionary optimization in open session management for 3D tele-immersion}},
	author={Arefin, Ahsan and Rivas, Raoul and Nahrstedt, Klara},
	booktitle={ACM MMSys},
	pages={226--237},
	year={2013},
	}
	
	@inproceedings{agarwal2010bundle,
	title={{Bundle of streams: Concept and evaluation in distributed interactive multimedia environments}},
	author={Agarwal, Pooja and Toledano, Raoul Rivas and Wu, Wanmin and Nahrstedt, Klara and Arefin, Ahsan},
	booktitle={IEEE ISM},
	pages={25--32},
	year={2010},
	}
	
	@inproceedings{chen20143dti,
	title={{3DTI amphitheater: a manageable 3DTI environment with hierarchical stream prioritization}},
	author={Chen, Shannon and Nahrstedt, Klara and Gupta, Indranil},
	booktitle={ACM MMSys},
	pages={70--80},
	year={2014},
	}
	
	
	@inproceedings{devincenzi2011kinected,
	title={{Kinected conference: augmenting video imaging with calibrated depth and audio}},
	author={DeVincenzi, Anthony and Yao, Lining and Ishii, Hiroshi and Raskar, Ramesh},
	booktitle={ACM CSCW},
	pages={621--624},
	year={2011},
	}
	
	@inproceedings{hosseini2015coordinated,
	title={{Coordinated bandwidth adaptations for distributed 3d tele-immersive systems}},
	author={Hosseini, Mohammad and Kurillo, Gregorij},
	booktitle={ACM International Workshop on Massively Multiuser Virtual Environments},
	pages={13--18},
	year={2015},
	}
	
	
	@inproceedings{mekuria20133d,
	title={{A 3d tele-immersion system based on live captured mesh geometry}},
	author={Mekuria, Rufael and Sanna, Michele and Asioli, Stefano and Izquierdo, Ebroul and Bulterman, Dick CA and Cesar, Pablo},
	booktitle={ACM MMSys},
	pages={24--35},
	year={2013}
	} 
	
	@inproceedings{alexiadis2012reconstruction,
	title={{Reconstruction for 3D immersive virtual environments}},
	author={Alexiadis, Dimitrios S and Kordelas, Georgios and Apostolakis, Konstantinos C and Agapito, Juan D and Vegas, JM and Izquierdo, Ebroul and Daras, Petros},
	booktitle={IEEE International Workshop on Image Analysis for Multimedia Interactive Services},
	pages={1--4},
	year={2012},
	} 
	
	@inproceedings{kodera2014multi,
	title={{Multi-view video streaming with mobile cameras}},
	author={Kodera, Shiho and Fujihashi, Takuya and Saruwatari, Shunsuke and Watanabe, Takashi},
	booktitle={IEEE GLOBECOM},
	pages={1412--1417},
	year={2014},
	}
	
	@inproceedings{lou2005real,
	title={{A real-time interactive multi-view video system}},
	author={Lou, Jian-Guang and Cai, Hua and Li, Jiang},
	booktitle={ACM Multimedia},
	pages={161--170},
	year={2005},
	organization={ACM}
	}
	
	@inproceedings{huang2010tsync,
	title={{Tsync: A new synchronization framework for multi-site 3d tele-immersion}},
	author={Huang, Zixia and Wu, Wanmin and Nahrstedt, Klara and Arefin, Ahsan and Rivas, Raoul},
	booktitle={ACM NOSSDAV Workshop},
	pages={39--44},
	year={2010},
	}
	
	@inproceedings{huang2011synccast,
	title={{SyncCast: synchronized dissemination in multi-site interactive 3D tele-immersion}},
	author={Huang, Zixia and Wu, Wanmin and Nahrstedt, Klara and Rivas, Raoul and Arefin, Ahsan},
	booktitle={ACM Multimedia systems (MMSys)},
	pages={69--80},
	year={2011},
	organization={ACM}
	}
	
	#Math 
	
	@article{kelly2001mathematical,
	title={Mathematical modelling of the Internet},
	author={Kelly, Frank P},
	journal={Mathematics unlimited-2001 and beyond},
	volume={1},
	pages={685--702},
	year={2001},
	} 
	
	@article{matta2013optimizing,
	title={{Optimizing and Modeling Dynamics in Networks}},
	author={Matta, Ibrahim and Haddadi, H and Bonaventure, O},
	journal={ACM SIGCOMM Book on Recent Advances in Networking},
	volume={1},
	year={2013}
	} 
	
	@inproceedings{matta2000differentiated,
	title={{Differentiated predictive fair service for TCP flows}},
	author={Matta, Ibrahim and Guo, Liang},
	booktitle={IEEE ICNP},
	pages={49--58},
	year={2000}
	}
	
	@inproceedings{smolic20063d,
	title={{3D video and free viewpoint video-technologies, applications and MPEG standards}},
	author={Smolic, Aljoscha and Mueller, Karsten and Merkle, Philipp and Fehn, Christoph and Kauff, Peter and Eisert, Peter and Wiegand, Thomas},
	booktitle={IEEE International Conference on Multimedia and Expo},
	pages={2161--2164},
	year={2006},
	}
	
	@article{vetro2011overview,
	title={Overview of the stereo and multiview video coding extensions of the H. 264/MPEG-4 AVC standard},
	author={Vetro, Anthony and Wiegand, Thomas and Sullivan, Gary J},
	journal={Proceedings of the IEEE},
	volume={99},
	number={4},
	pages={626--642},
	year={2011},
	} 
	
	@inproceedings{hamza2014dash,
	title={{A dash-based free viewpoint video streaming system}},
	author={Hamza, Ahmed and Hefeeda, Mohamed},
	booktitle={ACM NOSSDAV Workshop},
	pages={55},
	year={2014}
	}
	
	#SDN-Multimedia
	
	@inproceedings{kleinrouweler2016delivering,
	title={{Delivering stable high-quality video: an SDN architecture with DASH assisting network elements}},
	author={Kleinrouweler, Jan Willem and Cabrero, Sergio and Cesar, Pablo},
	booktitle={ACM Multimedia Systems (MMSys)},
	pages={4},
	year={2016}
	}
	
	@inproceedings{georgopoulos2013towards,
	title={{Towards network-wide QoE fairness using openflow-assisted adaptive video streaming}},
	author={Georgopoulos, Panagiotis and Elkhatib, Yehia and Broadbent, Matthew and Mu, Mu and Race, Nicholas},
	booktitle={Proceedings of the 2013 ACM SIGCOMM workshop on Future human-centric multimedia networking},
	pages={15--20},
	year={2013},
	organization={ACM}
	} 
	
	@inproceedings{cofano2016design,
	title={{Design and experimental evaluation of network-assisted strategies for HTTP adaptive streaming}},
	author={Cofano, Giuseppe and De Cicco, Luca and Zinner, Thomas and Nguyen-Ngoc, Anh and Tran-Gia, Phuoc and Mascolo, Saverio},
	booktitle={ACM Multimedia Systems (MMSys)},
	pages={3},
	year={2016}
	}
	
	#BPF
	
	@inproceedings{mccanne1993bsd,
	title={{The BSD Packet Filter: A New Architecture for User-level Packet Capture.}},
	author={McCanne, Steven and Jacobson, Van},
	booktitle={USENIX winter},
	volume={93},
	year={1993}
	}
	
	#Hardware
	
	@article{zilberman2014netfpga,
	title={{NetFPGA SUME: Toward 100 Gbps as research commodity}},
	author={Zilberman, Noa and Audzevich, Yury and Covington, G Adam and Moore, Andrew W},
	journal={IEEE Micro},
	volume={34},
	number={5},
	pages={32--41},
	year={2014},
	publisher={IEEE}
	} 
	
	@inproceedings{mccanne1993bsd,
	title={{The BSD Packet Filter: A New Architecture for User-level Packet Capture.}},
	author={McCanne, Steven and Jacobson, Van},
	booktitle={USENIX winter},
	volume={93},
	year={1993}
	}
	
	
	@article{kicinskiebpf,
	title={{eBPF Hardware Offload to SmartNICs: cls bpf and XDP}},
	author={Kicinski, Jakub and Viljoen, Nicolaas},
	journal={Netdev 1.2},
	year={2016}
	}
	
	@article{busypolling,
	title={{Busy Polling: Past, Present, Future}},
	author={Eric Dumazet},
	journal={Netdev 2.1},
	year={2017}
	}
	 
	@inproceedings{chole2017drmt,
	title={{dRMT: Disaggregated Programmable Switching}},
	author={Chole, Sharad and Fingerhut, Andy and Ma, Sha and Sivaraman, Anirudh and Vargaftik, Shay and Berger, Alon and Mendelson, Gal and Alizadeh, Mohammad and Chuang, Shang-Tse and Keslassy, Isaac and others},
	booktitle={ACM SIGCOMM},
	pages={1--14},
	year={2017}
	}  
	
	
	@inproceedings{bosshart2013forwarding,
	title={{Forwarding metamorphosis: Fast programmable match-action processing in hardware for SDN}},
	author={Bosshart, Pat and Gibb, Glen and Kim, Hun-Seok and Varghese, George and McKeown, Nick and Izzard, Martin and Mujica, Fernando and Horowitz, Mark},
	booktitle={ACM SIGCOMM Computer Communication Review},
	volume={43},
	number={4},
	pages={99--110},
	year={2013}
	}
	
	@inproceedings{de2009plug,
	title={{PLUG: flexible lookup modules for rapid deployment of new protocols in high-speed routers}},
	author={De Carli, Lorenzo and Pan, Yi and Kumar, Amit and Estan, Cristian and Sankaralingam, Karthikeyan},
	booktitle={ACM SIGCOMM Computer Communication Review},
	volume={39},
	number={4},
	pages={207--218},
	year={2009}
	}
	
	
	@inproceedings{dobrescu2009routebricks,
	title={{RouteBricks: exploiting parallelism to scale software routers}},
	author={Dobrescu, Mihai and Egi, Norbert and Argyraki, Katerina and Chun, Byung-Gon and Fall, Kevin and Iannaccone, Gianluca and Knies, Allan and Manesh, Maziar and Ratnasamy, Sylvia},
	booktitle={ACM SIGOPS SOSP},
	pages={15--28},
	year={2009}
	}
	
	@inproceedings{wentzlaff2010operating,
	title={{An operating system for multicore and clouds: Mechanisms and implementation}},
	author={Wentzlaff, David and Gruenwald III, Charles and Beckmann, Nathan and Modzelewski, Kevin and Belay, Adam and Youseff, Lamia and Miller, Jason and Agarwal, Anant},
	booktitle={ACM symposium on Cloud computing},
	pages={3--14},
	year={2010}
	} 
	  
	
	@inproceedings{pongracz2013cheap,
	title={{Cheap silicon: a myth or reality? picking the right data plane hardware for software defined networking}},
	author={Pongr{\'a}cz, Gergely and Moln{\'a}r, L{\'a}szl{\'o} and Kis, Zolt{\'a}n Lajos and Tur{\'a}nyi, Zolt{\'a}n},
	booktitle={ACM SIGCOMM workshop on Hot topics in Software Defined Networking},
	pages={103--108},
	year={2013},
	}
	
	
	@inproceedings{sharma17evaluating,
	title={{Evaluating the Power of Flexible Packet Processing for Network Resource Allocation}},
	author={Sharma, Naveen Kr and Kaufmann, Antoine and Anderson, Thomas and Kim, Changhoon and Krishnamurthy, Arvind and Nelson, Jacob and Peter, Simon},
	booktitle={USENIX NSDI},
	pages={67--82},
	year={2017},
	} 
	
	#NIC
	
	@inproceedings{shinde2013we,
	title={{We need to talk about NICs}},
	author={Shinde, Pravin and Kaufmann, Antoine and Roscoe, Timothy and Kaestle, Stefan},
	booktitle={USENIX HotOS},
	pages={1--1},
	year={2013}
	}
	
	@inproceedings{kaufmann2015flexnic,
	title={{FlexNIC: Rethinking Network DMA.}},
	author={Kaufmann, Antoine and Peter, Simon and Anderson, Thomas E and Krishnamurthy, Arvind},
	booktitle={HotOS},
	year={2015}
	}
	
	
	@inproceedings{belay2014ix,
	title={{IX: A protected dataplane operating system for high throughput and low latency}},
	author={Belay, Adam and Prekas, George and Klimovic, Ana and Grossman, Samuel and Kozyrakis, Christos and Bugnion, Edouard},
	booktitle={USENIX Symposium on Operating System Design and Implementation (OSDI)},
	number={EPFL-CONF-201671},
	year={2014},
	} 
	
	
	@inproceedings{dobrescu2009routebricks,
	title={{RouteBricks: exploiting parallelism to scale software routers}},
	author={Dobrescu, Mihai and Egi, Norbert and Argyraki, Katerina and Chun, Byung-Gon and Fall, Kevin and Iannaccone, Gianluca and Knies, Allan and Manesh, Maziar and Ratnasamy, Sylvia},
	booktitle={ACM SOSP},
	pages={15--28},
	year={2009}
	} 
	
	@inproceedings{han2010packetshader,
	title={{PacketShader: a GPU-accelerated software router}},
	author={Han, Sangjin and Jang, Keon and Park, KyoungSoo and Moon, Sue},
	booktitle={ACM SIGCOMM CCR},
	volume={40},
	number={4},
	pages={195--206},
	year={2010}
	}
	
	@inproceedings{li2013gamt,
	title={{GAMT: a fast and scalable IP lookup engine for GPU-based software routers}},
	author={Li, Yanbiao and Zhang, Dafang and Liu, Alex X and Zheng, Jintao},
	booktitle={ACM/IEEE ANCS},
	pages={1--12},
	year={2013}
	}
	
	
	@inproceedings{barbette2015fast,
	title={{Fast userspace packet processing}},
	author={Barbette, Tom and Soldani, Cyril and Mathy, Laurent},
	booktitle={ ACM/IEEE Symposium on Architectures for networking and communications systems (ANCS)},
	pages={5--16},
	year={2015}
	}
	
	
	
	@misc{rizzo201210,
	title={{10 Gbit/s line rate packet processing using commodity hardware: Survey and new proposals}},
	author={Rizzo, Luigi and Deri, Luca and Cardigliano, Alfredo},
	year={2012},
	publisher={US}
	}
	
	@inproceedings{rizzo2012netmap,
	title={{Netmap: a novel framework for fast packet I/O}},
	author={Rizzo, Luigi},
	booktitle={21st USENIX Security Symposium (USENIX Security 12)},
	pages={101--112},
	year={2012}
	}
	
	@inproceedings{gallenmuller2015comparison,
	title={{Comparison of frameworks for high-performance packet IO}},
	author={Gallenm{\"u}ller, Sebastian and Emmerich, Paul and Wohlfart, Florian and Raumer, Daniel and Carle, Georg},
	booktitle={ACM/IEEE ANCS},
	pages={29--38},
	year={2015}
	}
	
	@techreport{linguaglossa2017high,
	title={{High-speed software data plane via vectorized packet processing}},
	author={Linguaglossa, Leonardo and Rossi, Dario and Barach, Dave and Marjon, Damjan and Pfiester, Pierre},
	year={2017},
	institution={Technical report, Telecom ParisTech}
	}
	
	@inproceedings{hoiland2018express,
	title={{The eXpress Data Path: Fast Programmable Packet Processing in the Operating System Kernel}},
	author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
	booktitle={ACM CoNEXT},
	year={2018}
	}
	
	
	
	@article{han2015softnic,
	title={{SoftNIC: A software NIC to augment hardware}},
	author={Han, Sangjin and Jang, Keon and Panda, Aurojit and Palkar, Shoumik and Han, Dongsu and Ratnasamy, Sylvia},
	journal={Dept. EECS, Univ. California, Berkeley, Berkeley, CA, USA, Tech. Rep. UCB/EECS-2015-155},
	year={2015}
	}
	
	
	@inproceedings{shafer2007ricenic,
	title={{RiceNIC: A reconfigurable network interface for experimental research and education}},
	author={Shafer, Jeffrey and Rixner, Scott},
	booktitle={ACM workshop on Experimental computer science},
	pages={21},
	year={2007}
	}
	
	@phdthesis{scheidegger2011barrelfish,
	title={{Barrelfish on netronome}},
	author={Scheidegger, Bram and Peter, Simon and Baumann, Andrew and Roscoe, Timothy},
	year={2011},
	school={Master’s thesis, ETH Zurich}
	}
	
	@inproceedings{argyraki2008can,
	title={{Can software routers scale?}},
	author={Argyraki, Katerina and Baset, Salman and Chun, Byung-Gon and Fall, Kevin and Iannaccone, Gianluca and Knies, Allan and Kohler, Eddie and Manesh, Maziar and Nedevschi, Sergiu and Ratnasamy, Sylvia},
	booktitle={ACM workshop on Programmable routers for extensible services of tomorrow},
	pages={21--26},
	year={2008}
	}
	
	@inproceedings{baumann2009multikernel,
	title={{The multikernel: a new OS architecture for scalable multicore systems}},
	author={Baumann, Andrew and Barham, Paul and Dagand, Pierre-Evariste and Harris, Tim and Isaacs, Rebecca and Peter, Simon and Roscoe, Timothy and Sch{\"u}pbach, Adrian and Singhania, Akhilesh},
	booktitle={ACM SOSP},
	pages={29--44},
	year={2009}
	}
	
	#TCAM
	@article{kuo2014memory,
	title={{A memory-efficient TCAM coprocessor for IPv4/IPv6 routing table update}},
	author={Kuo, Fang-Chen and Chang, Yeim-Kuan and Su, Cheng-Chien},
	journal={IEEE Transactions on Computers},
	volume={63},
	number={9},
	pages={2110--2121},
	year={2014},
	}
	
	@inproceedings{zhou2013scalable,
	title={{Scalable, high performance ethernet forwarding with cuckooswitch}},
	author={Zhou, Dong and Fan, Bin and Lim, Hyeontaek and Kaminsky, Michael and Andersen, David G},
	booktitle={ACM CoNEXT},
	pages={97--108},
	year={2013}
	}
	
	
	#Performance measurement
	@book{mosberger2001ia,
	title={{IA-64 Linux kernel: design and implementation}},
	author={Mosberger, David and Eranian, Stephane},
	year={2001},
	publisher={Prentice Hall PTR}
	}
	
	@article{guide2011intel,
	title={{Intel{\textregistered} 64 and IA-32 Architectures Software Developer’s Manual}},
	author={Guide, Part},
	journal={Volume 3B: System programming Guide, Part},
	volume={2},
	year={2011}
	}
	
	#Network Measurement
	@inproceedings{estan2003bitmap,
	title={{Bitmap algorithms for counting active flows on high speed links}},
	author={Estan, Cristian and Varghese, George and Fisk, Mike},
	booktitle={ACM SIGCOMM conference on Internet measurement},
	pages={153--166},
	year={2003}
	}


@MISC{ripe,
	key = {{RIPE Network Coordination Centre}},
	title = {{RIPE Network Coordination Centre}},
	note = {
	\url{https://www.ripe.net/}
	},
	language = {english},
}
 
@MISC{routeviews,
	key = {{Route Views Project}},
	title = {{Route Views Project}},
	note = {
	\url{http://www.routeviews.org/routeviews/}
	},
	language = {english},
}
 
@MISC{bgpreport,
	key = {{BGP Report}},
	title = {{BGP Report}},
	note = {
	\url{http://bgp.potaroo.net/}
	},
	language = {english},
}

@MISC{x86instructions,
	key = {{x86 Instruction Set Reference}},
	title = {{x86 Instruction Set Reference}},
	note = {
	\url{https://c9x.me/x86/}
	},
	language = {english},
}

@inproceedings{vanjacobson,
  author = "Van Jacobson and Michael J. Karels",
  title = "Congestion Avoidance and Control",
  booktitle = "SIGCOMM 1988",
  address = "Stanford, CA",
  month = aug,
  year = 1988
}

@inproceedings{yang2014guarantee,
	title={{Guarantee IP lookup performance with FIB explosion}},
	author={Yang, Tong and Xie, Gaogang and Li, YanBiao and Fu, Qiaobin and Liu, Alex X and Li, Qi and Mathy, Laurent},
	booktitle={ACM SIGCOMM 2014},
}

@inproceedings{asai2015poptrie,
	title={{Poptrie: A compressed trie with population count for fast and scalable software IP routing table lookup}},
	author={Asai, Hirochika and Ohara, Yasuhiro},
	booktitle={ACM SIGCOMM 2015},
} 

@article{nilsson1999ip,
	title={{IP-address lookup using LC-tries}},
	author={Nilsson, Stefan and Karlsson, Gunnar},
	journal={IEEE Journal on selected Areas in Communications},
	volume={17},
	number={6},
	pages={1083--1092},
	year={1999},
}

@inproceedings{gallenmuller2015comparison,
	title={{Comparison of frameworks for high-performance packet IO}},
	author={Gallenm{\"u}ller, Sebastian and Emmerich, Paul and Wohlfart, Florian and Raumer, Daniel and Carle, Georg},
	booktitle={ACM/IEEE ANCS},
	year={2015}
}


@article{eatherton2004tree,
	title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
	author={Eatherton, Will and Varghese, George and Dittia, Zubin},
	journal={ACM SIGCOMM},
	volume={34},
	number={2},
	pages={97--122},
	year={2004},
}

@inproceedings{gupta1998routing,
	title={Routing lookups in hardware at memory access speeds},
	author={Gupta, Pankaj and Lin, Steven and McKeown, Nick},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1240--1247},
	year={1998}
}

@inproceedings{zhou2013scalable,
	title={{Scalable, high performance ethernet forwarding with CuckooSwitch}},
	author={Zhou, Dong and Fan, Bin and Lim, Hyeontaek and Kaminsky, Michael and Andersen, David G},
	booktitle=ACM CoNEXT},
	pages={97--108},
	year={2013}
}


@inproceedings{fu2006performance,
	title={{Performance evaluation and cache behavior of LC-trie for IP-address lookup}},
	author={Fu, Jing and Hagsand, Olof and Karlsson, Gunnar},
	booktitle={IEEE Workshop on High Performance Switching and Routing},
	pages={7--pp},
	year={2006},
}
 
@article{zec2012dxr,
	title={{DXR: towards a billion routing lookups per second in software}},
	author={Zec, Marko and Rizzo, Luigi and Mikuc, Miljenko},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={42},
	number={5},
	pages={29--36},
	year={2012},
}

@inproceedings{retvari2013compressing,
	title={{Compressing IP forwarding tables: towards entropy bounds and beyond}},
	author={R{\'e}tv{\'a}ri, G{\'a}bor and Tapolcai, J{\'a}nos and K{\H{o}}r{\"o}si, Attila and Majd{\'a}n, Andr{\'a}s and Heszberger, Zal{\'a}n},
	booktitle={ACM SIGCOMM Computer Communication Review},
	volume={43},
	number={4},
	pages={111--122},
	year={2013}
}


@article{degermark1997small,
	title={Small forwarding tables for fast routing lookups},
	author={Degermark, Mikael and Brodnik, Andrej and Carlsson, Svante and Pink, Stephen},
	journal={ACM SIGCOMM},
	volume={27},
	number={4},
	year={1997}
}

  
@inproceedings{pongracz2013cheap,
	title={{Cheap silicon: a myth or reality? picking the right data plane hardware for software defined networking}},
	author={Pongr{\'a}cz, Gergely and Moln{\'a}r, L{\'a}szl{\'o} and Kis, Zolt{\'a}n Lajos and Tur{\'a}nyi, Zolt{\'a}n},
	booktitle={ACM SIGCOMM workshop on Hot topics in Software Defined Networking},
	pages={103--108},
	year={2013},
}
 
 
@MISC{dpdk,
	key = {{dpdk}},
	title = {{Data Plane Development Kit (DPDK)}},
	note = {
	\url{http://dpdk.org/}
	},
	language = {english},
}

@MISC{fibbackbone,
	key = {{Routing tables of backbone routers}},
	title = {{Routing tables of backbone routers}},
	note = {
	\url{https://github.com/tamimcse/parse-bgpdump/}
	},
	language = {english},
}

@MISC{sailpatch,
	key = {{SAIL-BM implementation in Linux kernel}},
	title = {{SAIL-BM implementation in Linux kernel}},
	note = {
	\url{https://github.com/tamimcse/kernel-patches/blob/master/xdp-sail.patch/}
	},
	language = {english},
}


@MISC{vpp,
	key = {{vpp}},
	title = {{Vector Packet Processing (VPP)}},
	note = {
	\url{https://wiki.fd.io/view/VPP}
	},
	language = {english},
}
 

@MISC{odp,
	key = {{odp}},
	title = {{OpenDataPlane(ODP)}},
	note = {
	\url{https://www.opendataplane.org/}
	},
	language = {english},
} 
 
@MISC{xdp,
	key = {{XDP}},
	title = {{XDP (eXpress Data path)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
	},
	language = {english},
}

@inproceedings{hoiland2018express,
	title={{The eXpress Data Path: Fast Programmable Packet Processing in the Operating System Kernel}},
	author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
	booktitle={ACM CoNEXT},
	year={2018},
}
 

@book{warren2013hacker,
	title={{Hacker's delight}},
	author={Warren, Henry S},
	year={2013},
	publisher={Pearson Education}
}

@article{fog2011instruction,
	title={{Instruction tables: Lists of instruction latencies, throughputs and micro-operation breakdowns for Intel, AMD and VIA CPUs}},
	author={Fog, Agner and others},
	journal={Copenhagen University College of Engineering},
	volume={97},
	pages={114},
	year={2011}
}


@article{guide2011intel,
	title={{Intel{\textregistered} 64 and IA-32 Architectures Software Developer’s Manual}},
	author={Guide, Part},
	journal={Volume 3B: System programming Guide, Part},
	volume={2},
	year={2011}
}

@inproceedings{so2013named,
	title={{Named data networking on a router: Fast and DoS-resistant forwarding with hash tables}},
	author={So, Won and Narayanan, Ashok and Oran, David},
	booktitle={ACM/IEEE ANCS},
	pages={215--226},
	year={2013}
}


@inproceedings{estan2003bitmap,
	title={Bitmap algorithms for counting active flows on high speed links},
	author={Estan, Cristian and Varghese, George and Fisk, Mike},
	booktitle={ACM SIGCOMM IMC},
	pages={153--166},
	year={2003}
}

@article{flajolet1985probabilistic,
	title={Probabilistic counting algorithms for data base applications},
	author={Flajolet, Philippe and Martin, G Nigel},
	journal={Journal of computer and system sciences},
	volume={31},
	number={2},
	pages={182--209},
	year={1985},
	publisher={Elsevier}
}

@inproceedings{fan2014cuckoo,
	title={{Cuckoo filter: Practically better than bloom}},
	author={Fan, Bin and Andersen, Dave G and Kaminsky, Michael and Mitzenmacher, Michael D},
	booktitle={ACM SIGCOMM CoNEXT},
	pages={75--88},
	year={2014}
}

#Micro engine programming

@book{comer2004network,
	title={{Network Systems Design: Using Network Processors}},
	author={Comer, Douglas and Peterson, Larry},
	year={2004},
	publisher={Pearson/Prentice Hall}
}
 
@book{packetC,
	title={{PacketC Programming}},
	author={Jungck, Peder and Duncan, Ralph and Mulcahy, Dwight },
	year={2011},
	publisher={Apress}
}

@inproceedings{duncan2009packetc,
	title={{packetC language for high performance packet processing}},
	author={Duncan, Ralph and Jungck, Peder},
	booktitle={IEEE International Conference on High Performance Computing and Communications (HPCC)},
	pages={450--457},
	year={2009}
}


@article{shah2004np,
	title={{NP-click: A productive software development approach for network processors}},
	author={Shah, Niraj and Plishker, William and Ravindran, Kaushik and Keutzer, Kurt},
	journal={IEEE Micro},
	number={5},
	pages={45--54},
	year={2004}
}

@article{kicinski2016ebpf,
	title={{eBPF Hardware Offload to SmartNICs: cls bpf and XDP}},
	author={Kicinski, Jakub and Viljoen, Nicolaas},
	journal={Netdev 1.2},
	year={2016}
}

@article{viljoenusing,
	title={{Using eBPF as an Abstraction for Switching}},
	author={Viljoen, Nicolaas and Kicinski, Jakub},
	journal={Linux Plumber Conference},
	year={2018}
}

@MISC{tejac,
	key = {{Teja Technologies}},
	title = {{Teja Technologies}},
	note = {
	\url{http://www.teja.com}
	},
	language = {english},
}

@article{karlin2002vera,
	title={{VERA: An extensible router architecture}},
	author={Karlin, Scott and Peterson, Larry},
	journal={Computer Networks},
	volume={38},
	number={3},
	pages={277--293},
	year={2002},
	publisher={Elsevier}
}

@inproceedings{campbell2002netbind,
	title={{Netbind: A binding tool for constructing data paths in network processor-based routers}},
	author={Campbell, Andrew T and Chou, Stephen T and Kounavis, Michael E and Stachtos, Vassilis D and Vicente, John},
	booktitle={IEEE Open Architectures and Network Programming Proceedings},
	pages={91--103},
	year={2002},
	organization={IEEE}
}
  
@inproceedings{lee2004towards,
	title={{Towards a generic programming model for network processors}},
	author={Lee, Kevin and Coulson, Geoff and Blair, Gordon and Joolia, Ackbar and Ueyama, Jo},
	booktitle={IEEE ICON},
	volume={2},
	pages={504--510},
	year={2004}
}

@article{coulson2003netkit,
	title={{NETKIT: a software component-based approach to programmable networking}},
	author={Coulson, Geoff and Blair, Gordon and Hutchison, David and Joolia, Ackbar and Lee, Kevin and Ueyama, Jo and Gomes, Antonio and Ye, Yimin},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={33},
	number={5},
	pages={55--66},
	year={2003}
}


@inproceedings{chen2005shangri,
	title={{Shangri-La: achieving high performance from compiled network applications while enabling ease of programming}},
	author={Chen, Michael K and Li, Xiao Feng and Lian, Ruiqi and Lin, Jason H and Liu, Lixia and Liu, Tao and Ju, Roy},
	booktitle={ACM SIGPLAN Notices},
	volume={40},
	number={6},
	pages={224--236},
	year={2005},
	organization={ACM}
}   
  
@inproceedings{attig2011400,
	title={{400 gb/s programmable packet parsing on a single FPGA}},
	author={Attig, Michael and Brebner, Gordon},
	booktitle={ACM/IEEE ANCS},
	pages={12--23},
	year={2011}
}

 
@inproceedings{george2003taming,
	title={{Taming the IXP network processor}},
	author={George, Lal and Blume, Matthias},
	booktitle={ACM SIGPLAN PLDI},
	volume={38},
	number={5},
	pages={26--37},
	year={2003}
}

@inproceedings{sivaraman2016packet,
	title={{Packet transactions: High-level programming for line-rate switches}},
	author={Sivaraman, Anirudh and Cheung, Alvin and Budiu, Mihai and Kim, Changhoon and Alizadeh, Mohammad and Balakrishnan, Hari and Varghese, George and McKeown, Nick and Licking, Steve},
	booktitle={ACM SIGCOMM},
	pages={15--28},
	year={2016}
}

@article{solar2006combinatorial,
	title={Combinatorial sketching for finite programs},
	author={Solar-Lezama, Armando and Tancau, Liviu and Bodik, Rastislav and Seshia, Sanjit and Saraswat, Vijay},
	journal={ACM ASPLOS},
	volume={41},
	number={11},
	pages={404--415},
	year={2006}
}

@inproceedings{kim2015band,
	title={{In-band network telemetry via programmable dataplanes}},
	author={Kim, Changhoon and Sivaraman, Anirudh and Katta, Naga and Bas, Antonin and Dixit, Advait and Wobker, Lawrence J},
	booktitle={ACM SIGCOMM},
	year={2015}
}
